Loading...
Searching...
No Matches
Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix > Class Template Reference
Persistence Matrix

Class managing the pivot and partitioning of columns in Chain_matrix. More...

`#include <gudhi/Persistence_matrix/columns/chain_column_extra_properties.h>`

## Public Types

using | Index = typename Master_matrix::Index
using | ID_index = typename Master_matrix::ID_index

## Public Member Functions

| Chain_column_extra_properties ()
| Default constructor. Sets the pivot and pair to null index, which means "not existing".
| Chain_column_extra_properties (ID_index pivot)
| Constructor setting the pivot at the given value and the pair to null index (i.e. not paired).
| Chain_column_extra_properties (ID_index pivot, Index pair)
| Constructor setting the pivot and the pair at the given values.
| Chain_column_extra_properties (const Chain_column_extra_properties &col)
| Copy constructor.
| Chain_column_extra_properties (Chain_column_extra_properties &&col)
| Move constructor.
Index | get_paired_chain_index () const
| Returns null index if the column is not paired, the MatIdx of the pair otherwise.
bool | is_paired () const
| Indicates if the column is paired or not.
void | assign_paired_chain (Index other_col)
| Sets the value of the pair.
void | unassign_paired_chain ()
| Un-pairs a column.
Chain_column_extra_properties & | operator= (const Chain_column_extra_properties &other)
| Assign operator.

## Friends

void | swap (Chain_column_extra_properties &col1, Chain_column_extra_properties &col2)
| Swap operator.

## Detailed Description

template<class Master_matrix>
class Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >

Class managing the pivot and partitioning of columns in Chain_matrix.

The columns of a chain matrix are partitioned in three sets: \( F \), \( G \) and \( H \) with a bijection between \( G \) and \( H \). If a column is in \( F \), the value of Chain_column_extra_properties::pairedColumn_ is null index, while the value corresponds to the MatIdx index of the image of the bijection if the column is in either \( G \) or \( H \). See [zigzag] for more details.

Template Parameters

  Master_matrix | An instantiation of Matrix from which all types and options are deduced.

## Member Typedef Documentation

## ID_index

template<class Master_matrix>

using Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::ID_index = typename Master_matrix::ID_index

IDIdx index type.

## Index

template<class Master_matrix>

using Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::Index = typename Master_matrix::Index

MatIdx index type.

## Constructor & Destructor Documentation

## Chain_column_extra_properties() [1/4]

template<class Master_matrix>

Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::Chain_column_extra_properties | ( | ID_index | pivot | ) |

inline

Constructor setting the pivot at the given value and the pair to null index (i.e. not paired).

Parameters

  pivot | Row index of the pivot. Corresponds to the IDIdx index of the cell represented by the column.

## Chain_column_extra_properties() [2/4]

template<class Master_matrix>

Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::Chain_column_extra_properties | ( | ID_index | pivot,
|  | Index | pair )

inline

Constructor setting the pivot and the pair at the given values.

Parameters

  pivot | Row index of the pivot. Corresponds to the IDIdx index of the cell represented by the column.
  pair | MatIdx index of the pair of the column.

## Chain_column_extra_properties() [3/4]

template<class Master_matrix>

Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::Chain_column_extra_properties | ( | const Chain_column_extra_properties< Master_matrix > & | col | ) |

inline

Copy constructor.

Parameters

  col | Column to copy.

## Chain_column_extra_properties() [4/4]

template<class Master_matrix>

Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::Chain_column_extra_properties | ( | Chain_column_extra_properties< Master_matrix > && | col | ) |

inline

Move constructor.

Parameters

  col | Column to move.

## Member Function Documentation

## assign_paired_chain()

template<class Master_matrix>

void Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::assign_paired_chain | ( | Index | other_col | ) |

inline

Sets the value of the pair.

Parameters

  other_col | MatIdx of the pair column.

## get_paired_chain_index()

template<class Master_matrix>

Index Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::get_paired_chain_index | ( |  | ) | const

inline

Returns null index if the column is not paired, the MatIdx of the pair otherwise.

Returns
  null index if the column is not paired, the MatIdx of the pair otherwise.

## is_paired()

template<class Master_matrix>

bool Gudhi::persistence_matrix::Chain_column_extra_properties< Master_matrix >::is_paired | ( |  | ) | const

inline

Indicates if the column is paired or not.

Returns
  true If the column is paired.
  false Otherwise.

The documentation for this class was generated from the following file:

- include/gudhi/Persistence_matrix/columns/chain_column_extra_properties.h